package com.bzd.web.controller.xsgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.xsgl.SXsglXsmxZkmxSalesdiscountinfoService;

import java.util.List;

/**
*
* 销售折扣明细 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "xsgl/sxsglxsmxzkmxsalesdiscountinfo")
public class SXsglXsmxZkmxSalesdiscountinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "xsgl";

    @Autowired
    private SXsglXsmxZkmxSalesdiscountinfoService sXsglXsmxZkmxSalesdiscountinfoService;

    /**
    * 销售折扣明细 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("xsgl:xs:view")
    @GetMapping("/sXsglXsmxZkmxSalesdiscountinfoAdd")
    public String add() {
        return prefix + "/SXsglXsmxZkmxSalesdiscountinfoAdd";
    }

    /**
    * 销售折扣明细 新增
    *
    * @return
    */
    @Log(title = "销售折扣明细新增", businessType = BusinessType.INSERT)
    @PostMapping("/sXsglXsmxZkmxSalesdiscountinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sXsglXsmxZkmxSalesdiscountinfoService.addSXsglXsmxZkmxSalesdiscountinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 销售折扣明细 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("xsgl:xs:view")
    @GetMapping("/sXsglXsmxZkmxSalesdiscountinfoView")
    public String sxsglxsmxzkmxsalesdiscountinfoListView() {
        return prefix + "/SXsglXsmxZkmxSalesdiscountinfoList";
    }

    /**
    * 销售折扣明细 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:sXsglXsmxZkmxSalesdiscountinfoList")
    @PostMapping("/sXsglXsmxZkmxSalesdiscountinfoList")
    @ResponseBody
    public TableDataInfo sxsglxsmxzkmxsalesdiscountinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sXsglXsmxZkmxSalesdiscountinfoService.findSXsglXsmxZkmxSalesdiscountinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 销售折扣明细 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:remove")
    @Log(title = "销售折扣明细删除", businessType = BusinessType.DELETE)
    @PostMapping("/sXsglXsmxZkmxSalesdiscountinfoRemove")
    @ResponseBody
    public AjaxResult sxsglxsmxzkmxsalesdiscountinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sXsglXsmxZkmxSalesdiscountinfoService.SXsglXsmxZkmxSalesdiscountinfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 销售折扣明细 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:edit")
    @GetMapping("/sXsglXsmxZkmxSalesdiscountinfoEdit/{id}")
    public String sxsglxsmxzkmxsalesdiscountinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sXsglXsmxZkmxSalesdiscountinfoService.findSXsglXsmxZkmxSalesdiscountinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sxsglxsmxzkmxsalesdiscountinfoPageEdit";
        }
        return prefix+ "/sxsglxsmxzkmxsalesdiscountinfoEdit";
    }

    /**
    * 销售折扣明细保存修改的数据
    */
    @RequiresPermissions("xsgl:xs:edit")
    @Log(title = "销售折扣明细修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sXsglXsmxZkmxSalesdiscountinfoEdit")
    @ResponseBody
    public AjaxResult sxsglxsmxzkmxsalesdiscountinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sXsglXsmxZkmxSalesdiscountinfoService.updateSXsglXsmxZkmxSalesdiscountinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sxsglxsmxzkmxsalesdiscountinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sxsglxsmxzkmxsalesdiscountinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
